﻿#[compute]
#version 450

layout(local_size_x = 8, local_size_y = 8, local_size_z = 1) in;

layout(rgba16f, set = 0, binding = 0) uniform image2D color_image;
layout(set = 1, binding = 0) uniform sampler2D depth_texture;
layout(set = 2, binding = 0) uniform sampler2D normal_texture;

layout(push_constant, std430) uniform Params {
	vec2 raster_size;
	vec2 reserved;
} params;

void main() {
	ivec2 xy = ivec2(gl_GlobalInvocationID.xy);
	ivec2 size = ivec2(params.raster_size);

	if (xy.x >= size.x || xy.y >= size.y) {
		return;
	}

    vec2 uv = vec2(xy + vec2(0.5, 0.5)) / params.raster_size;
    vec3 normal = texture(normal_texture, uv).xyz;
	imageStore(color_image, xy, vec4(normal,1.0));
}